## hdf-eos5 5.1.16.dfsg.1

=== Makefile ===
#----------------------------------------------------------------------------
# file:         makefile for HDF-EOS5 (for internal ECS usage only)
#
# environment:  requires environment established by the ECS .buildrc file
# 
# environment variables dependencies:
#   MAKECMD  make command to be run on make files
#   ARCH     architecture (i.e. hardware/os type)
#
#
# author:  Guru Tej S. Khalsa / Space Applications Corp.
#          Abe Taaheri / Emergent Information Technologies, Inc.
#
# history:
#       10-Nov-1997 GTSK Initital version
#       11-Apr-2001 AT   modified for HDFEOS5 and HDF5
#       19-Jul-2001 DaW  Modified because it broke the Build
#       05-Apr-2004 AT   Modified for DAAC Linux Delivery
#       02-Feb-2013 AT   Modified for Toolkit Linux64 build in clearcase
#
#
# notes:
#       1) This file is only for use by ECS Configuration Management (CM)
#	   personnel and software.  This file should not be distributed
#	   as part of the standard HDF-EOS5 delivery.
#----------------------------------------------------------------------------

# define shell to be used (use ksh so we can use the "." command)

SHELL=/bin/ksh

# define MAKE to be equivalant to $(MAKECMD)

MAKE=$(MAKECMD)

# define the location of the HDF-EOS5 STAGE area

HE_STAGE=/ecs/formal/STAGE/hdfeos5

# define the location of the standard HDF-EOS5 development area

HE_HOME=/ecs/hdfeos5

# define HDF5 base directory

#HE_ENV=$(ARCH)

# define the location of tar files

TAR_HOME=$(HE_HOME)/install

HDF_BASE=/ecs/cots/hdf

# define current HDF version

CURRENT_HDF4=HDF4.2.10
CURRENT_HDF=hdf5-1.8.12
CURRENT_SZIP=szip-2.1

# define SDP Toolkit home directory

TK_HOME=/ecs/formal/TOOLKIT

# name of tar files for delivery
HDFEOS5_SOURCE_TAR=HDF-EOS5.1.16.tar
HDFEOS5_TESTDRIVERS_TAR=HDF-EOS5.1.16_TESTDRIVERS.tar

# define the default compiler optimization level
OPT_LVL=-g

# define default target

default:
	@echo "This file is for use by ECS Configuration Management processes only."

# define a target to build BOTH variations (or "flavors") of HDF-EOS5
# for a given "brand" (i.e. architecture type)

full: opt debug

# define a target to build the "debug" variation (or "flavor") of HDF-EOS5
# for a given "brand" (i.e. architecture type) ("debug" means the library
# will be compiled for use in a souce code debugger)

debug:
	@$(MAKE) flavor_dir FLAVOR=$@
	@export use_flavor=1; $(MAKE) $(TARGET) OPT_LVL=-g FLAVOR=$@

# define a target to build the "optimized" variation (or "flavor") of
# HDF-EOS5 for a given "brand" (i.e. architecture type) ("optimized" means the
# library will be optimized for execution speed by the compiler)

opt:
	@$(MAKE) flavor_dir FLAVOR=$@
	@export use_flavor=1; $(MAKE) $(TARGET) OPT_LVL=-O FLAVOR=$@

# define standard CM targets

# NOTE: The standard targets defined by ECS CM are:
#       BuildImake, ProductHs, ProductLibs, LastPass, Deliver
#
#       Here the above targets are shadowed by the targets:
#       BuildImake2, ProductHs2, ProductLibs2, LastPass2, Deliver2
#       respectively.  The original targets only call the target
#       HE_ENV which sets up the HDF-EOS5 environment and then
#       builds the shadow target.
#       For SGI 32 Falvor build or linux 12 Falvor build these targets
#       renamed to FL_......


BuildImake:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

BuildImake2:
	@echo "No Imakefile to build."

ProductHs:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

ProductHs2:
	@echo "No header files to generate or promote."

ProductLibs: ProductLibs32 ProductLibs64

ProductLibs32:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

ProductLibs322:
	@if [ ! -e $(HDFEOS5_HOME)/lib/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/lib;			\
		ln -s `basename $(HDFEOS5_LIB)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp5

ProductLibs64:
	@$(MAKE) $(MFLAGS) HE_ENV64 TARGET=$@2

ProductLibs642:
	@if [ ! -e $(HDFEOS5_HOME)/lib/$(ARCH)64 ] ; then	\
		cd $(HDFEOS5_HOME)/lib;			\
		ln -s `basename $(HDFEOS5_LIB)` $(ARCH)64;\
	fi
	@cd $(HDFEOS5_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp5

LastPass:LastPass32 LastPass64

LastPass32:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

LastPass322:
	@if [ ! -e $(HDFEOS5_HOME)/bin/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/bin;			\
		ln -s `basename $(HDFEOS5_BIN)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/util; $(MAKE) $(MFLAGS) all

LastPass64:
	@$(MAKE) $(MFLAGS) HE_ENV64 TARGET=$@2

LastPass642:
	@if [ ! -e $(HDFEOS5_HOME)/bin/$(ARCH)64 ] ; then	\
		cd $(HDFEOS5_HOME)/bin;			\
		ln -s `basename $(HDFEOS5_BIN)` $(ARCH)64;\
	fi
	@cd $(HDFEOS5_HOME)/util; $(MAKE) $(MFLAGS) all

#	@echo "No utilites to build."

FL_BuildImake:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_BuildImake2:
	@echo "No Imakefile to build."

FL_ProductHs:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_ProductHs2:
	@echo "No header files to generate or promote."

FL_ProductLibs:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_ProductLibs2:
	@if [ ! -e $(HDFEOS5_HOME)/lib/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/lib;			\
		ln -s `basename $(HDFEOS5_LIB)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp5

FL_LastPass:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_LastPass2:
	@if [ ! -e $(HDFEOS5_HOME)/bin/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/bin;			\
		ln -s `basename $(HDFEOS5_BIN)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/util; $(MAKE) $(MFLAGS) all

#	@echo "No utilites to build."



Deliver:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

Deliver2:
#	cp -rf /ecs/hdfeos/gctp .
#	chmod 0755 gctp/src/* gctp/include/*
	tar cvfX $(TAR_HOME)/$(HDFEOS5_SOURCE_TAR) $(HE_HOME)/make_exclude_list -C /ecs hdfeos5
	tar cvfX $(TAR_HOME)/$(HDFEOS5_TESTDRIVERS_TAR)  $(HE_HOME)/testdrivers/make_exclude_list -C /ecs  hdfeos5/testdrivers

DaacDeliver:
	@if [ $(ARCH) = "sgi6n32" ] ; then				    \
		for arch in sgi6n32 sgi6 ; do			    	    \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
				$(MAKECMD) full TARGET=$$targ ARCH=$$arch;  \
			done;						    \
		done;							    \
	elif [ $(ARCH) = "irix65" ] ; then				    \
		for arch in sgi6n32 sgi6 ; do			            \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
				$(MAKECMD) full TARGET=$$targ ARCH=$$arch;  \
			done;						    \
		done;                                                       \
	else								    \
		for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do		    \
			$(MAKECMD) full TARGET=$$targ;			    \
		done;							    \
	fi

LinuxDaacDeliver:  
	@if [ $(ARCH) = "linux" ] ; then				\
		for arch in linux ; do					\
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	\
			$(MAKECMD) full TARGET=$$targ ARCH=$$arch;	\
		done ;							\
		done ;							\
	fi



# this is a special target used to establish the HDF-EOS5 environment

FL_HE_ENV:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;			\
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;		\
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux; brand=$(ARCH) ;;  \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	postfix=""; 						\
	opt_flag=-O;						\
	case $(FLAVOR) in					\
		*debug)						\
			opt_flag=-g;				\
			postfix=_debug;				\
		;;						\
	esac;							\
	HDFEOS5_HOME=$(HE_HOME);				\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS5_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/$${brand}$$postfix/hdfeos_env.ksh;	\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDF5INC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDF5LIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDF5INC PGSINC SZIPINC SZIPLIB HDF5LIB;	\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/lib		\
	export HDFINC HDFLIB;					\
	$(MAKE) $(MFLAGS) $(TARGET)


HE_ENV:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;			\
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;		\
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux; brand=$(ARCH) ;;    \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	HDFEOS5_HOME=$(HE_HOME);				\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS5_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/tmp/hdfeos_env.ksh.tmp;		\
	if [ $(ARCH) = "linux" ] ; then				\
	CC="gcc -m32";						\
	export CC;						\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	fi;							\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDF5INC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDF5LIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDF5INC PGSINC SZIPINC SZIPLIB HDF5LIB;	\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/lib		\
	export HDFINC HDFLIB;					\
	$(MAKE) $(MFLAGS) $(TARGET)

HE_ENV64:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;			\
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;		\
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux64; brand=$(ARCH)64 ;;\
		*)       brand=$(ARCH); ;;			\
	esac;							\
	HDFEOS5_HOME=$(HE_HOME);				\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS5_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/tmp/hdfeos_env.ksh.tmp;		\
	if [ $(ARCH) = "linux" ] ; then				\
	CC="gcc -fPIC";						\
	export CC;						\
	LNX_COMP_FLAG="";					\
	export LNX_COMP_FLAG;					\
	fi;							\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDF5INC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDF5LIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDF5INC PGSINC SZIPINC SZIPLIB HDF5LIB;	\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/lib		\
	export HDFINC HDFLIB;					\
	$(MAKE) $(MFLAGS) $(TARGET)

flavor_dir:
	@sgi_mode=sgi32;					\
	LNX_COMP_FLAG="-m32";			                \
	export LNX_COMP_FLAG;					\
	opt_flag=-O;						\
	postfix="";						\
	case $(FLAVOR) in					\
		*debug)						\
			opt_flag=-g;				\
			postfix=_debug;				\
		;;						\
	esac;							\
	case $(ARCH) in						\
		hp10)						\
			brand=hp;				\
		;;						\
		sgi6n32)					\
			brand=sgi32;				\
			sgi_mode=n32;				\
		;;						\
		irix65)                                         \
			brand=irix65;				\
			sgi_mode=65;				\
		;;						\
		sgi6)						\
			brand=sgi64;				\
			sgi_mode=64;				\
		;;						\
		sun5.5)						\
			brand=sun5;				\
		;;						\
		sun5.8)						\
			brand=sun5.8;				\
		;;						\
		*)						\
			brand=$(ARCH);				\
		;;						\
	esac;							\
	he_obj=$(HE_HOME)/obj/$${brand}$$postfix;		\
	he_lib=$(HE_HOME)/lib/$${brand}$$postfix;		\
	he_bin=$(HE_HOME)/bin/$${brand}$$postfix;		\
	tmpdir=$(HE_HOME)/bin/tmp;				\
	if [ ! -d $$he_obj ] ; then				\
		mkdir $$he_obj;					\
	fi;							\
	if [ ! -d $$he_lib ] ; then				\
		mkdir $$he_lib;					\
	fi;							\
	if [ ! -d $$he_bin ] ; then				\
		mkdir $$he_bin;					\
	fi;							\
	hdf5lib=$(HDF_BASE)/$${brand}/$(CURRENT_HDF)/lib;	\
	hdf5inc=$(HDF_BASE)/$${brand}/$(CURRENT_HDF)/include;	\
	sziplib=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	szipinc=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	if [ ! -f $$he_bin/hdfeos_env.csh ] ; then			\
		cd $$he_bin;						\

=== gctp/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (GCTP C CXX)

ADD_SUBDIRECTORY (${GCTP_SOURCE_DIR}/src      ${GCTP_BINARY_DIR}/src)

=== gctp/Makefile ===
#-------------------------------------------------------------------------#
#                                                                         #
#  COPYRIGHT[copyright mark] 2000, Raytheon System Company, its vendors,  #
#  and suppliers.  ALL RIGHTS RESERVED.                                   #
#                                                                         #
#-------------------------------------------------------------------------#
#----------------------------------------------------------------------------
# file:		makefile for GCTP
# 	
# environment variables dependencies:
#   compiler:  CC CFHFLAGS
#  
# author:  Sbe Taaheri 
#
# history:
#	17 Sep-2002 AT Initial version
#       11 Oct-2005 AT updated for Solaris 9 and 10
#       27 Feb-2006 TR Updated for winnt98 (cygwin)
#       23 sep-2015 AT updated for Solaris 11
#----------------------------------------------------------------------------

# force make to use the 'sh' shell
SHELL = /bin/sh

# name of remove utility
RM= /bin/rm
RMFLAGS= -f 

all: finc select_brand dfinc

INCFILES =	\
	src/bcea.h	\
	src/cproj.h	\
	src/isin.h	\
	src/proj.h	\
	src/gctp_prototypes.h \
	src/cproj_prototypes.h

finc: $(INCFILES)

src/bcea.h: include/bcea.h
	cp $? $@

src/cproj.h: include/cproj.h
	cp $? $@

src/isin.h: include/isin.h
	cp $? $@

src/proj.h: include/proj.h
	cp $? $@

src/gctp_prototypes.h: include/gctp_prototypes.h
	cp $? $@

src/cproj_prototypes.h: include/cproj_prototypes.h
	cp $? $@

select_brand:
	@if [ $(BRAND) = "sun5" ] ; then \
		cd src; $(MAKE) -f makesol25 ; \
	elif [ $(BRAND) = "hp" ] ; then \
		cd src; $(MAKE) -f makehp ; \
	elif [ $(BRAND) = "hp11" ] ; then \
		cd src; $(MAKE) -f makehp11 ; \
	elif [ $(BRAND) = "dec" ] ; then \
		cd src; $(MAKE) -f makedec ; \
	elif [ $(BRAND) = "ibm" ] ; then \
		cd src; $(MAKE) -f makeibm ; \
	elif [ $(BRAND) = "irix65" ] ; then \
		cd src; $(MAKE) -f makesgi65_64 ; \
		$(MAKE) -f makesgi65_n32 ; \
	elif [ $(BRAND) = "linux" ] ; then \
		cd src; $(MAKE) -f makelinux ; \
	elif [ $(BRAND) = "sgi" ] ; then \
		cd src; $(MAKE) -f makesgi32 ; \
	elif [ $(BRAND) = "sgi32" ] ; then \
		cd src; $(MAKE) -f makesgin32 ; \
	elif [ $(BRAND) = "sgi64" ] ; then \
		cd src; $(MAKE) -f makesgi64 ; \
	elif [ $(BRAND) = "sun5.8" ] ; then \
		cd src; $(MAKE) -f makesol28 ; \
	elif [ $(BRAND) = "sun5.9" ] ; then \
		cd src; $(MAKE) -f makesol29 ; \
	elif [ $(BRAND) = "sun5.10" ] ; then \
		cd src; $(MAKE) -f makesol210 ; \
	elif [ $(BRAND) = "sun5.11" ] ; then \
		cd src; $(MAKE) -f makesol211 ; \
	elif [ $(BRAND) = "winnt98" ] ; then \
		cd src; $(MAKE) -f makecygwin ; \
	elif [ $(BRAND) = "macintosh" ] ; then \
		cd src; $(MAKE) -f makemacintosh ; \
	elif [ $(BRAND) = "macintel" ] ; then \
		cd src; $(MAKE) -f makemacintel ; \
	elif [ $(BRAND) = "macintel32" ] ; then \
		cd src; $(MAKE) -f makemacintel32 ; \
	elif [ $(BRAND) = "macintel64" ] ; then \
		cd src; $(MAKE) -f makemacintel64 ; \
	else \
		echo " The brand $(BRAND) is not supported. " ; \
		echo " Set the env. vriable BRAND to a supported one then make this makefile"; \
	fi ;

clean:
	$(RM) $(RMFLAGS) core *.o
	$(RM) $(RMFLAGS) src/*.o


dfinc:
	@$(RM) $(RMFLAGS) $(INCFILES)

=== samples/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_SAMPLES)

#-----------------------------------------------------------------------------
# Define Sources
#-----------------------------------------------------------------------------
SET (samples
    he5_gd_datainfo
    he5_gd_defexternalfld
    he5_gd_definefields
    he5_gd_defunlimfld
    he5_gd_info
    he5_gd_rdexternaldata
    he5_gd_readdata
    he5_gd_writedata
    he5_gd_setup
    he5_gd_subset
    he5_gd_wrexternaldata
    he5_gd_wrunlimfld
    he5_pt_datainfo
    he5_pt_definelevels
    he5_pt_readattrs
    he5_pt_readdata
    he5_pt_setup
    he5_pt_updatelevels
    he5_pt_writeattrs
    he5_pt_writedata
    he5_sw_datainfo
    he5_sw_defexternalfld
    he5_sw_definefields
    he5_sw_defunlimfld
    he5_sw_info
    he5_sw_rdexternaldata
    he5_sw_readdata
    he5_sw_setup
    he5_sw_subset
    he5_sw_wrextendrd
    he5_sw_wrexternaldata
    he5_sw_writedata
    he5_sw_wrunlimfld
    he5_za_datainfo
    he5_za_defexternalfld
    he5_za_definefields
    he5_za_info
    he5_za_rdexternaldata
    he5_za_readdata
    he5_za_setup
    he5_za_wrexternaldata
    he5_za_writedata
)

FOREACH (sample ${samples})
  ADD_EXECUTABLE (${sample} ${PROJECT_SOURCE_DIR}/${sample}.c)
  TARGET_NAMING (${sample} ${LIB_TYPE})
  TARGET_LINK_LIBRARIES (${sample} ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
ENDFOREACH (sample ${samples})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  SET (fort_samples
    he5_gd_definefields
    he5_gd_info
    he5_gd_readdata
    he5_gd_writedata
    he5_gd_setup
    he5_gd_subset
    he5_pt_datainfo
    he5_pt_definelevels
    he5_pt_readattrs
    he5_pt_readdata
    he5_pt_setup
    he5_pt_updatelevels
    he5_pt_writeattrs
    he5_pt_writedata
    he5_sw_defexternalfld
#    he5_sw_definefields
    he5_sw_info
    he5_sw_rdexternaldata
    he5_sw_readdata
    he5_sw_setup
    he5_sw_subset
    he5_sw_wrexternaldata
    he5_sw_writedata
    he5_za_defexternalfld
    he5_za_definefields
    he5_za_info
    he5_za_rdexternaldata
    he5_za_readdata
    he5_za_setup
    he5_za_wrexternaldata
    he5_za_writedata
  )

  FOREACH (sample ${fort_samples})
    IF (F2CFORTRAN_32PTR)
      ADD_EXECUTABLE (f_${sample} ${PROJECT_SOURCE_DIR}/${sample}F_32.f)
    ELSE (F2CFORTRAN_32PTR)
      ADD_EXECUTABLE (f_${sample} ${PROJECT_SOURCE_DIR}/${sample}F_64.f)
    ENDIF (F2CFORTRAN_32PTR)
    TARGET_NAMING (f_${sample} ${LIB_TYPE})
    TARGET_FORTRAN_WIN_PROPERTIES (f_${sample} "")
    SET_TARGET_PROPERTIES (f_${sample} PROPERTIES LINKER_LANGUAGE Fortran)
    TARGET_LINK_LIBRARIES (f_${sample} ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
  ENDFOREACH (sample ${fort_samples})

  #special test for he5_sw_definefields
  IF (HDF5_ENABLE_SZIP_SUPPORT)
    IF (F2CFORTRAN_32PTR)
      ADD_EXECUTABLE (f_he5_sw_definefields ${PROJECT_SOURCE_DIR}/he5_sw_definefields_szipF_32.f)
    ELSE (F2CFORTRAN_32PTR)
      ADD_EXECUTABLE (f_he5_sw_definefields ${PROJECT_SOURCE_DIR}/he5_sw_definefields_szipF_64.f)
    ENDIF (F2CFORTRAN_32PTR)
  ELSE (HDF5_ENABLE_SZIP_SUPPORT)
    IF (F2CFORTRAN_32PTR)
      ADD_EXECUTABLE (f_he5_sw_definefields ${PROJECT_SOURCE_DIR}/he5_sw_definefieldsF_32.f)
    ELSE (F2CFORTRAN_32PTR)
      ADD_EXECUTABLE (f_he5_sw_definefields ${PROJECT_SOURCE_DIR}/he5_sw_definefieldsF_64.f)
    ENDIF (F2CFORTRAN_32PTR)
  ENDIF (HDF5_ENABLE_SZIP_SUPPORT)
  TARGET_NAMING (f_he5_sw_definefields ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (f_he5_sw_definefields "")
  SET_TARGET_PROPERTIES (f_he5_sw_definefields PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (f_he5_sw_definefields ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)
  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME gd_write_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove  Grid.h5
  )
  SET (gdwt_last_test "gd_write_test-clearall-objects")

  SET (gd_write_test
    he5_gd_setup
    he5_gd_definefields
    he5_gd_writedata
    he5_gd_readdata
    he5_gd_info
    he5_gd_datainfo
    he5_gd_subset
  )
  FOREACH (sample ${gd_write_test})
    ADD_TEST (NAME gd_write_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    IF (NOT "${gdwt_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (gd_write_test_${sample} PROPERTIES DEPENDS ${gdwt_last_test})
    ENDIF (NOT "${gdwt_last_test}" STREQUAL "")
    SET (gdwt_last_test "gd_write_test_${sample}")
  ENDFOREACH (sample ${gd_write_test})
  
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/unlim")

  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME gd_unlim_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove  Grid.h5
  )
  SET_TESTS_PROPERTIES (gd_unlim_test-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/unlim")
  SET (gdut_last_test "gd_unlim_test-clearall-objects")

  SET (gd_unlim_test
    he5_gd_setup
    he5_gd_defunlimfld
    he5_gd_wrunlimfld
  )
  FOREACH (sample ${gd_unlim_test})
    ADD_TEST (NAME gd_unlim_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    SET_TESTS_PROPERTIES (gd_unlim_test_${sample} PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/unlim")
    IF (NOT "${gdut_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (gd_unlim_test_${sample} PROPERTIES DEPENDS ${gdut_last_test})
    ENDIF (NOT "${gdut_last_test}" STREQUAL "")
    SET (gdut_last_test "gd_unlim_test_${sample}")
  ENDFOREACH (sample ${gd_unlim_test})

  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME pt_write_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove Point.h5
  )
  SET (ptwt_last_test "pt_write_test-clearall-objects")

  SET (pt_write_test
    he5_pt_setup
    he5_pt_definelevels
    he5_pt_writedata
    he5_pt_writeattrs
    he5_pt_readdata
    he5_pt_readattrs
    he5_pt_updatelevels
    he5_pt_datainfo
  )
 
  FOREACH (sample ${pt_write_test})
    ADD_TEST (NAME pt_write_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    SET_TESTS_PROPERTIES (pt_write_test_${sample} PROPERTIES ENVIRONMENT "srcdir=${PROJECT_SOURCE_DIR}")
    IF (NOT "${ptwt_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (pt_write_test_${sample} PROPERTIES DEPENDS ${ptwt_last_test})
    ENDIF (NOT "${ptwt_last_test}" STREQUAL "")
    SET (ptwt_last_test "pt_write_test_${sample}")
  ENDFOREACH (sample ${pt_write_test})

  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME sw_write_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove  Swath.h5
  )
  SET (swwt_last_test "sw_write_test-clearall-objects")

  SET (sw_write_test
    he5_sw_setup
    he5_sw_definefields
    he5_sw_writedata
    he5_sw_readdata
    he5_sw_info
    he5_sw_datainfo
    he5_sw_subset
  )
  FOREACH (sample ${sw_write_test})
    ADD_TEST (NAME sw_write_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    IF (NOT "${swwt_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (sw_write_test_${sample} PROPERTIES DEPENDS ${swwt_last_test})
    ENDIF (NOT "${swwt_last_test}" STREQUAL "")
    SET (swwt_last_test "sw_write_test_${sample}")
  ENDFOREACH (sample ${sw_write_test})
  
  # make test dir
#  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/unlim")

  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME sw_unlim_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove  Swath.h5
  )
  SET_TESTS_PROPERTIES (sw_unlim_test-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/unlim")
  SET (swut_last_test "sw_unlim_test-clearall-objects")

  SET (sw_unlim_test
    he5_sw_setup
    he5_sw_defunlimfld
    he5_sw_wrunlimfld
    he5_sw_subset
  )
  FOREACH (sample ${sw_unlim_test})
    ADD_TEST (NAME sw_unlim_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    SET_TESTS_PROPERTIES (sw_unlim_test_${sample} PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/unlim")
    IF (NOT "${swut_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (sw_unlim_test_${sample} PROPERTIES DEPENDS ${swut_last_test})
    ENDIF (NOT "${swut_last_test}" STREQUAL "")
    SET (swut_last_test "sw_unlim_test_${sample}")
  ENDFOREACH (sample ${sw_unlim_test})
  
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/extend")

  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME sw_extend_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove  Swath.h5
  )
  SET_TESTS_PROPERTIES (sw_extend_test-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/extend")
  SET (swxt_last_test "sw_extend_test-clearall-objects")

  SET (sw_extend_test
    he5_gd_setup
    he5_gd_defunlimfld
    he5_gd_wrunlimfld
  )
  FOREACH (sample ${sw_extend_test})
    ADD_TEST (NAME sw_extend_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    SET_TESTS_PROPERTIES (sw_extend_test_${sample} PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/extend")
    IF (NOT "${swxt_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (sw_extend_test_${sample} PROPERTIES DEPENDS ${swxt_last_test})
    ENDIF (NOT "${swxt_last_test}" STREQUAL "")
    SET (swxt_last_test "sw_extend_test_${sample}")
  ENDFOREACH (sample ${sw_extend_test})

  # Remove any output file left over from previous test run
  ADD_TEST (
      NAME za_write_test-clearall-objects
      COMMAND    ${CMAKE_COMMAND} -E remove  ZA.h5
  )
  SET (zawt_last_test "za_write_test-clearall-objects")

  SET (za_write_test
    he5_za_setup
    he5_za_definefields
    he5_za_writedata
    he5_za_readdata
    he5_za_info
    he5_za_datainfo
  )
  FOREACH (sample ${za_write_test})
    ADD_TEST (NAME za_write_test_${sample} COMMAND $<TARGET_FILE:${sample}>)
    IF (NOT "${zawt_last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (za_write_test_${sample} PROPERTIES DEPENDS ${zawt_last_test})
    ENDIF (NOT "${zawt_last_test}" STREQUAL "")
    SET (zawt_last_test "za_write_test_${sample}")
  ENDFOREACH (sample ${za_write_test})

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    # Remove any output file left over from previous test run
    ADD_TEST (
        NAME gd_write_test_fortran-clearall-objects
        COMMAND    ${CMAKE_COMMAND} -E remove Grid.h5
    )
    SET_TESTS_PROPERTIES (gd_write_test_fortran-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET (gdwtf_last_test "gd_write_test_fortran-clearall-objects")

    SET (gd_write_test_fortran
      he5_gd_setup
      he5_gd_definefields
      he5_gd_writedata
      he5_gd_readdata
      he5_gd_info
      he5_gd_subset
    )
    FOREACH (sample ${gd_write_test_fortran})
      ADD_TEST (NAME gd_write_test_fortran_${sample} COMMAND $<TARGET_FILE:f_${sample}>)
      SET_TESTS_PROPERTIES (gd_write_test_fortran_${sample} PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
      IF (NOT "${gdwtf_last_test}" STREQUAL "")
        SET_TESTS_PROPERTIES (gd_write_test_fortran_${sample} PROPERTIES DEPENDS ${gdwtf_last_test})
      ENDIF (NOT "${gdwtf_last_test}" STREQUAL "")
      SET (gdwtf_last_test "gd_write_test_fortran_${sample}")
    ENDFOREACH (sample ${gd_write_test_fortran})

    # Remove any output file left over from previous test run
    ADD_TEST (
        NAME pt_write_test_fortran-clearall-objects
        COMMAND    ${CMAKE_COMMAND} -E remove Point.h5
    )

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_SRC C CXX)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
LINK_DIRECTORIES (
    ${HDFEOS5_SRC_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

SET (HDFEOS_CSRCS
    ${HDFEOS5_SRC_SOURCE_DIR}/EHapi.c
    ${HDFEOS5_SRC_SOURCE_DIR}/GDapi.c
    ${HDFEOS5_SRC_SOURCE_DIR}/PTapi.c
    ${HDFEOS5_SRC_SOURCE_DIR}/SWapi.c
    ${HDFEOS5_SRC_SOURCE_DIR}/TSapi.c
    ${HDFEOS5_SRC_SOURCE_DIR}/ZAapi.c
)

SET (HDFEOS_CHDRS
    ${HDFEOS_INC_DIR}/HE5_GctpFunc.h
    ${HDFEOS_INC_DIR}/HE5_HdfEosDef.h
#    ${HDFEOS_INC_DIR}/HE5_config.h
    ${HDFEOS_INC_DIR}/cproj.h
    ${HDFEOS_INC_DIR}/ease.h
    ${HDFEOS_INC_DIR}/isin.h
    ${HDFEOS_INC_DIR}/proj.h
    ${HDFEOS_INC_DIR}/tutils.h
    ${HDFEOS_INC_DIR}/cfortHdf.h
)

IF (H5_USE_HDFEOS2)
  ADD_DEFINITIONS (-DHAVE_LIBHDFEOS)
ENDIF (H5_USE_HDFEOS2)

ADD_LIBRARY (${HDFEOS_SRC_LIB_TARGET} ${LIB_TYPE} ${HDFEOS_CSRCS} ${HDFEOS_CHDRS})
IF (H5_USE_16_API_DEFAULT)
  ADD_DEFINITIONS (-DH5_USE_16_API)
ENDIF (H5_USE_16_API_DEFAULT)
IF(MSVC)
  TARGET_LINK_LIBRARIES (${HDFEOS_SRC_LIB_TARGET} "ws2_32.lib")
ELSE (MSVC)
  SET_TARGET_PROPERTIES (${HDFEOS_SRC_LIB_TARGET} PROPERTIES LINK_FLAGS "-Wl,-single_module")
ENDIF(MSVC)
TARGET_LINK_LIBRARIES (${HDFEOS_SRC_LIB_TARGET} ${LINK_LIBS})
SET_GLOBAL_VARIABLE (HDFEOS_LIBRARIES_TO_EXPORT "${HDFEOS_LIBRARIES_TO_EXPORT};${HDFEOS_SRC_LIB_TARGET}")
HDFEOS_SET_LIB_OPTIONS (${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_SRC_LIB_NAME} ${LIB_TYPE})

#-----------------------------------------------------------------------------
# Add file(s) to CMake Install
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)
  INSTALL (
      FILES
          ${HDFEOS_HEADERS}
      DESTINATION
          ${HDFEOS_INSTALL_INCLUDE_DIR}
      COMPONENT
          headers
  )
ENDIF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFEOS_EXPORTED_TARGETS)

  INSTALL_TARGET_PDB (${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_INSTALL_LIB_DIR} libraries)
  
  INSTALL (
      TARGETS 
          ${HDFEOS_SRC_LIB_TARGET}
      EXPORT
          ${HDFEOS_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HDFEOS_INSTALL_BIN_DIR} COMPONENT libraries
  )
ENDIF (HDFEOS_EXPORTED_TARGETS)

=== src/Makefile ===
# Copyright (C) 1996 Hughes and Applied Research Corporation
#
# Permission to use, modify, and distribute this software and its
# documentation for any purpose without fee is hereby granted, provided that
# the above copyright notice appear in all copies and that both that copyright
# notice and this permission notice appear in supporting documentation.
#
# Makefile
# 
# Makefile for field build of HDFEOS
#
# The following environment variables must be defined:
#
#   Flags:
#     AR           library archiving program and flags (e.g.: ar -r)
#     CC           C language compiler (e.g.: cc)
#     CFHFLAGS     C compiler flags and cfortran.h switches
#                  (e.g.: -Xa -O -DsunFortan)
#     RANLIB       ranlib program (e.g. ranlib)
#
#   Directories:
#     HDFEOS5_INC   HDF-EOS include directory ($HDFEOS5_HOME/include)
#     HDFEOS5_LIB   HDF-EOS library directory ($HDFEOS5_HOME/lib/$BRAND)
#     HDFEOS5_OBJ   HDF-EOS object directory ($HDFEOS5_HOME/obj/$BRAND)

# force make program to use bourne shell
SHELL=/bin/sh

# define remove utility
RM = rm -f 

AR = ar -r

# define C preprocessor symbols 
DFLAGS = -D$(HDFSYS)

# location of include files need to compile source code
IFLAGS = -I. -I$(HDFEOS5_INC) -I$(HDF5INC)

# object files needed to build library
LIBOFILES = \
	$(HDFEOS5_OBJ)/EHapi.o \
	$(HDFEOS5_OBJ)/TSapi.o \
	$(HDFEOS5_OBJ)/PTapi.o \
	$(HDFEOS5_OBJ)/GDapi.o \
	$(HDFEOS5_OBJ)/SWapi.o \
	$(HDFEOS5_OBJ)/ZAapi.o

# default target, this just builds the hdfeos5 library
all:
	@if [ "$(BRAND)" = "sun4" ] ; then				\
		$(MAKE) $(MFLAGS) $(HDFEOS5_LIB)/libhe5_hdfeos.a ranlib;	\
	else								\
		$(MAKE) $(MFLAGS) $(HDFEOS5_LIB)/libhe5_hdfeos.a;		\
	fi

$(HDFEOS5_LIB)/libhe5_hdfeos.a: $(LIBOFILES)
	$(AR) $@ $?

ranlib:
	$(RANLIB) $(HDFEOS5_LIB)/libhe5_hdfeos.a

install: 
	@echo "no binaries to move"
	@echo "don't worry"

clean:
	$(RM) *.o $(HDFEOS5_OBJ)/*.o


$(HDFEOS5_OBJ)/EHapi.o : EHapi.c 
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS5_OBJ)/TSapi.o : TSapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS5_OBJ)/PTapi.o : PTapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS5_OBJ)/SWapi.o : SWapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS5_OBJ)/GDapi.o : GDapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS5_OBJ)/ZAapi.o : ZAapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

.c.o:
	$(MAKE) $(MFLAGS) $(HDFEOS5_OBJ)/$@

=== testdrivers/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (TESTDRIVERS C CXX)

ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/swath      ${TESTDRIVERS_BINARY_DIR}/swath)
ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/grid       ${TESTDRIVERS_BINARY_DIR}/grid)
ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/point      ${TESTDRIVERS_BINARY_DIR}/point)
ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/za         ${TESTDRIVERS_BINARY_DIR}/za)
IF (H5_HAVE_THREADSAFE)
  ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/threads    ${TESTDRIVERS_BINARY_DIR}/threads)
ENDIF (H5_HAVE_THREADSAFE)

=== gctp/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (GCTP_SRC C CXX)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
LINK_DIRECTORIES (
    ${GCTP_SRC_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

SET (GCTP_SRC_CSRCS
    ${GCTP_SRC_SOURCE_DIR}/gctp.c
    ${GCTP_SRC_SOURCE_DIR}/alberfor.c
    ${GCTP_SRC_SOURCE_DIR}/alberinv.c
    ${GCTP_SRC_SOURCE_DIR}/alconfor.c
    ${GCTP_SRC_SOURCE_DIR}/alconinv.c
    ${GCTP_SRC_SOURCE_DIR}/azimfor.c
    ${GCTP_SRC_SOURCE_DIR}/aziminv.c
    ${GCTP_SRC_SOURCE_DIR}/bceafor.c
    ${GCTP_SRC_SOURCE_DIR}/bceainv.c
    ${GCTP_SRC_SOURCE_DIR}/br_gctp.c
    ${GCTP_SRC_SOURCE_DIR}/ceafor.c
    ${GCTP_SRC_SOURCE_DIR}/ceainv.c
    ${GCTP_SRC_SOURCE_DIR}/cproj.c
    ${GCTP_SRC_SOURCE_DIR}/eqconfor.c
    ${GCTP_SRC_SOURCE_DIR}/eqconinv.c
    ${GCTP_SRC_SOURCE_DIR}/equifor.c
    ${GCTP_SRC_SOURCE_DIR}/equiinv.c
    ${GCTP_SRC_SOURCE_DIR}/for_init.c
    ${GCTP_SRC_SOURCE_DIR}/gnomfor.c
    ${GCTP_SRC_SOURCE_DIR}/gnominv.c
    ${GCTP_SRC_SOURCE_DIR}/goodfor.c
    ${GCTP_SRC_SOURCE_DIR}/goodinv.c
    ${GCTP_SRC_SOURCE_DIR}/gvnspfor.c
    ${GCTP_SRC_SOURCE_DIR}/gvnspinv.c
    ${GCTP_SRC_SOURCE_DIR}/hamfor.c
    ${GCTP_SRC_SOURCE_DIR}/haminv.c
    ${GCTP_SRC_SOURCE_DIR}/imolwfor.c
    ${GCTP_SRC_SOURCE_DIR}/imolwinv.c
    ${GCTP_SRC_SOURCE_DIR}/inv_init.c
    ${GCTP_SRC_SOURCE_DIR}/isinusfor.c
    ${GCTP_SRC_SOURCE_DIR}/isinusinv.c
    ${GCTP_SRC_SOURCE_DIR}/lamazfor.c
    ${GCTP_SRC_SOURCE_DIR}/lamazinv.c
    ${GCTP_SRC_SOURCE_DIR}/lamccfor.c
    ${GCTP_SRC_SOURCE_DIR}/lamccinv.c
    ${GCTP_SRC_SOURCE_DIR}/merfor.c
    ${GCTP_SRC_SOURCE_DIR}/merinv.c
    ${GCTP_SRC_SOURCE_DIR}/millfor.c
    ${GCTP_SRC_SOURCE_DIR}/millinv.c
    ${GCTP_SRC_SOURCE_DIR}/molwfor.c
    ${GCTP_SRC_SOURCE_DIR}/molwinv.c
    ${GCTP_SRC_SOURCE_DIR}/obleqfor.c
    ${GCTP_SRC_SOURCE_DIR}/obleqinv.c
    ${GCTP_SRC_SOURCE_DIR}/omerfor.c
    ${GCTP_SRC_SOURCE_DIR}/omerinv.c
    ${GCTP_SRC_SOURCE_DIR}/orthfor.c
    ${GCTP_SRC_SOURCE_DIR}/orthinv.c
    ${GCTP_SRC_SOURCE_DIR}/paksz.c
    ${GCTP_SRC_SOURCE_DIR}/polyfor.c
    ${GCTP_SRC_SOURCE_DIR}/polyinv.c
    ${GCTP_SRC_SOURCE_DIR}/psfor.c
    ${GCTP_SRC_SOURCE_DIR}/psinv.c
    ${GCTP_SRC_SOURCE_DIR}/report.c
    ${GCTP_SRC_SOURCE_DIR}/robfor.c
    ${GCTP_SRC_SOURCE_DIR}/robinv.c
    ${GCTP_SRC_SOURCE_DIR}/sinfor.c
    ${GCTP_SRC_SOURCE_DIR}/sininv.c
    ${GCTP_SRC_SOURCE_DIR}/sphdz.c
    ${GCTP_SRC_SOURCE_DIR}/somfor.c
    ${GCTP_SRC_SOURCE_DIR}/sominv.c
    ${GCTP_SRC_SOURCE_DIR}/sterfor.c
    ${GCTP_SRC_SOURCE_DIR}/sterinv.c
    ${GCTP_SRC_SOURCE_DIR}/stplnfor.c
    ${GCTP_SRC_SOURCE_DIR}/stplninv.c
    ${GCTP_SRC_SOURCE_DIR}/tmfor.c
    ${GCTP_SRC_SOURCE_DIR}/tminv.c
    ${GCTP_SRC_SOURCE_DIR}/untfz.c
    ${GCTP_SRC_SOURCE_DIR}/utmfor.c
    ${GCTP_SRC_SOURCE_DIR}/utminv.c
    ${GCTP_SRC_SOURCE_DIR}/vandgfor.c
    ${GCTP_SRC_SOURCE_DIR}/vandginv.c
    ${GCTP_SRC_SOURCE_DIR}/wivfor.c
    ${GCTP_SRC_SOURCE_DIR}/wivinv.c
    ${GCTP_SRC_SOURCE_DIR}/wviifor.c
    ${GCTP_SRC_SOURCE_DIR}/wviiinv.c
)

SET (GCTP_HEADERS
    ${HDFEOS_GCTP_INC_DIR}/bcea.h
    ${HDFEOS_GCTP_INC_DIR}/cproj.h
    ${HDFEOS_GCTP_INC_DIR}/cproj_prototypes.h
    ${HDFEOS_GCTP_INC_DIR}/gctp_prototypes.h
    ${HDFEOS_GCTP_INC_DIR}/proj.h
    ${HDFEOS_GCTP_INC_DIR}/isin.h
)

ADD_LIBRARY (${HDFEOS_GCTP_SRC_LIB_TARGET} ${LIB_TYPE} ${GCTP_SRC_CSRCS} ${GCTP_HEADERS})
IF (H5_USE_16_API_DEFAULT)
  ADD_DEFINITIONS (-DH5_USE_16_API)
ENDIF (H5_USE_16_API_DEFAULT)
IF(MSVC)
  TARGET_LINK_LIBRARIES (${HDFEOS_GCTP_SRC_LIB_TARGET} "ws2_32.lib")
ENDIF(MSVC)
TARGET_LINK_LIBRARIES (${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
SET_GLOBAL_VARIABLE (HDFEOS_LIBRARIES_TO_EXPORT "${HDFEOS_LIBRARIES_TO_EXPORT};${HDFEOS_GCTP_SRC_LIB_TARGET}")
HDFEOS_SET_LIB_OPTIONS (${HDFEOS_GCTP_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_NAME} ${LIB_TYPE})

#-----------------------------------------------------------------------------
# Add file(s) to CMake Install
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)
  INSTALL (
      FILES
          ${GCTP_HEADERS}
      DESTINATION
          ${HDFEOS_INSTALL_INCLUDE_DIR}
      COMPONENT
          headers
  )
ENDIF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFEOS_EXPORTED_TARGETS)

  INSTALL_TARGET_PDB (${HDFEOS_GCTP_SRC_LIB_TARGET} ${HDFEOS_INSTALL_LIB_DIR} libraries)
  
  INSTALL (
      TARGETS 
          ${HDFEOS_GCTP_SRC_LIB_TARGET}
      EXPORT
          ${HDFEOS_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HDFEOS_INSTALL_BIN_DIR} COMPONENT libraries
  )
ENDIF (HDFEOS_EXPORTED_TARGETS)

=== testdrivers/grid/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_TESTDRIVERS_GRID)

ADD_EXECUTABLE (testgrid ${PROJECT_SOURCE_DIR}/TestGrid.c)
TARGET_NAMING (testgrid ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testgrid ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  IF (HDF5_ENABLE_SZIP_SUPPORT)
    SET (fort_testdriver_src testgrid_szip)
  ELSE (HDF5_ENABLE_SZIP_SUPPORT)
    SET (fort_testdriver_src testgrid)
  ENDIF (HDF5_ENABLE_SZIP_SUPPORT)

  IF (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testgrid_f ${PROJECT_SOURCE_DIR}/${fort_testdriver_src}32.f)
  ELSE (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testgrid_f ${PROJECT_SOURCE_DIR}/${fort_testdriver_src}64.f)
  ENDIF (F2CFORTRAN_32PTR)
  TARGET_NAMING (testgrid_f ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (testgrid_f "")
  SET_TARGET_PROPERTIES (testgrid_f PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (testgrid_f ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  ADD_TEST (NAME GRID_test_c COMMAND $<TARGET_FILE:testgrid>)

  ADD_TEST (NAME GRID_test_c_verbose COMMAND $<TARGET_FILE:testgrid> -v h)
  SET_TESTS_PROPERTIES (GRID_test_c_verbose PROPERTIES DEPENDS GRID_test_c)

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    # Remove any output file left over from previous test run
    ADD_TEST (
        NAME GRID_test_f-clearall-objects
        COMMAND    ${CMAKE_COMMAND} -E remove
            Grid3.hdf Gridc_Test.hdf Gridf_Test.hdf testgridf.txt
    )
    SET_TESTS_PROPERTIES (GRID_test_f-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (GRID_test_f-clearall-objects PROPERTIES DEPENDS GRID_test_c_verbose)

    ADD_TEST (NAME GRID_test_f COMMAND $<TARGET_FILE:testgrid_f>)
    SET_TESTS_PROPERTIES (GRID_test_f PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (GRID_test_f PROPERTIES DEPENDS GRID_test_f-clearall-objects)
  ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)

ENDIF (BUILD_TESTING)

=== testdrivers/point/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_TESTDRIVERS_POINT)

ADD_EXECUTABLE (testpoint ${PROJECT_SOURCE_DIR}/TestPoint.c)
TARGET_NAMING (testpoint ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testpoint ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  IF (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testpoint_f ${PROJECT_SOURCE_DIR}/testpoint32.f)
  ELSE (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testpoint_f ${PROJECT_SOURCE_DIR}/testpoint64.f)
  ENDIF (F2CFORTRAN_32PTR)
  TARGET_NAMING (testpoint_f ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (testpoint_f "")
  SET_TARGET_PROPERTIES (testpoint_f PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (testpoint_f ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

  SET (POINT_REFERENCE_FILES
    fixedBuoy0.txt
    fixedBuoy1.txt
    fixedBuoy1s.txt
    floatBuoy0.txt
    floatBuoy1.txt
    simple.txt
  )

  FOREACH (out_file ${POINT_REFERENCE_FILES})
    SET (outdest "${PROJECT_BINARY_DIR}/fortran/${out_file}")
    #MESSAGE (STATUS " Translating ${out_file}")
    ADD_CUSTOM_COMMAND (
        TARGET     testpoint_f
        POST_BUILD
        COMMAND    ${XLATE_UTILITY}
        ARGS       ${PROJECT_SOURCE_DIR}/${out_file} ${outdest}
    )
  ENDFOREACH (out_file ${POINT_REFERENCE_FILES})
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  ADD_TEST (NAME POINT_test_c COMMAND $<TARGET_FILE:testpoint>)
  SET_TESTS_PROPERTIES (POINT_test_c PROPERTIES ENVIRONMENT "srcdir=${PROJECT_SOURCE_DIR}")

  ADD_TEST (NAME POINT_test_c_verbose COMMAND $<TARGET_FILE:testpoint> -v h)
  SET_TESTS_PROPERTIES (POINT_test_c_verbose PROPERTIES ENVIRONMENT "srcdir=${PROJECT_SOURCE_DIR}")
  SET_TESTS_PROPERTIES (POINT_test_c_verbose PROPERTIES DEPENDS POINT_test_c)

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    ADD_TEST (NAME POINT_test_f COMMAND $<TARGET_FILE:testpoint_f>)
    SET_TESTS_PROPERTIES (POINT_test_f PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (POINT_test_f PROPERTIES ENVIRONMENT "srcdir=${PROJECT_SOURCE_DIR}")
    SET_TESTS_PROPERTIES (POINT_test_f PROPERTIES DEPENDS POINT_test_c_verbose)
  ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)

ENDIF (BUILD_TESTING)

=== testdrivers/swath/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_TESTDRIVERS_SWATH)

ADD_EXECUTABLE (testswath ${PROJECT_SOURCE_DIR}/TestSwath.c)
TARGET_NAMING (testswath ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testswath ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  IF (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testswath_f ${PROJECT_SOURCE_DIR}/testswath32.f)
  ELSE (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testswath_f ${PROJECT_SOURCE_DIR}/testswath64.f)
  ENDIF (F2CFORTRAN_32PTR)
  TARGET_NAMING (testswath_f ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (testswath_f "")
  SET_TARGET_PROPERTIES (testswath_f PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (testswath_f ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  ADD_TEST (NAME SWATH_test_c COMMAND $<TARGET_FILE:testswath>)

  ADD_TEST (NAME SWATH_test_c_verbose COMMAND $<TARGET_FILE:testswath> -v h)
  SET_TESTS_PROPERTIES (SWATH_test_c_verbose PROPERTIES DEPENDS SWATH_test_c)

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    ADD_TEST (NAME SWATH_test_f COMMAND $<TARGET_FILE:testswath_f>)
    SET_TESTS_PROPERTIES (SWATH_test_f PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (SWATH_test_f PROPERTIES DEPENDS SWATH_test_c_verbose)
  ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)

ENDIF (BUILD_TESTING)

=== debian/control ===
Source: hdf-eos5
Section: libs
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Standards-Version: 4.5.0
Homepage: https://www.hdfeos.org
Vcs-Browser: https://salsa.debian.org:/science-team/hdf-eos5.git
Vcs-Git: https://salsa.debian.org:/science-team/hdf-eos5.git
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo, 
  gfortran | fortran-compiler, 
  libhdf5-dev | libhdf5-mpi-dev, 
  libjpeg-dev, 
  libaec-dev,
  zlib1g-dev, 
  libtool, 
  libgctp-dev, 
  chrpath

Package: libhe5-hdfeos0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Earth Observation System extensions to HDF5
 HDF-EOS5 is a software library designed built on HDF5 to support EOS-specific
 data structures, namely Grid, Point, and Swath. The new data structures 
 are constructed from standard HDF data objects, using EOS conventions, through
 the use of a software library [1,4]. A key feature of HDF-EOS files is that
 instrument-independent services, such as subsetting by geolocation, can be
 applied to the files across a wide variety of data products. 
 The library is extensible and new data structures can be added.

Package: libhe5-hdfeos-dev
Architecture: any
Section: libdevel
Depends: libhe5-hdfeos0 (= ${binary:Version}), ${misc:Depends}, libgctp-dev
Recommends: pkg-config
Description:  Development files for the HDF-EOS5 library
 HDF-EOS5 is a software library designed built on HDF5 to support EOS-specific
 data structures, namely Grid, Point, and Swath. The new data structures 
 are constructed from standard HDF data objects, using EOS conventions, through
 the use of a software library. A key feature of HDF-EOS files is that
 instrument-independent services, such as subsetting by geolocation, can be
 applied to the files across a wide variety of data products. 
 .
 This package contains include files and static libraries for HDF-EOS5.

=== debian/rules ===
#!/usr/bin/make -f

# Comment out this line for debugging
export DH_VERBOSE:=1

# The magic rule for debhelper
%:
	dh $@ 

export HDF5_USE_SHLIB=yes
export CC=/usr/bin/h5cc

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

# Enforce shared lib linking# Enforce shared lib linking# Enforce shared lib linking# Enforce shared lib linking
export HDF5_USE_SHLIB=yes

# Disable checks: known bad test case ignored this release
DEB_CONFIGURE_EXTRA_FLAGS :=  --enable-shared --with-pic --with-szlib=/usr/include,$(LIBDIR)

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  DEB_CONFIGURE_EXTRA_FLAGS += --with-hdf5=/usr/include/hdf5/serial,/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

export DEB_CFLAGS_MAINT_APPEND=-D_HDFEOS5_THREADSAFE -Df2cFortran
export DEB_LDFLAGS_MAINT_APPEND=-lpthread

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)
	# Needed for the pthreads tests
	cp  samples/simple.txt testdrivers/threads

override_dh_auto_test:
	dh_auto_test || echo "Ignoring test failures"

override_dh_auto_fixperms:
	dh_fixperms
	#mkdir -p debian/libhe5-hdfeos-dev/${LIBDIR}/pkgconfig debian/libhe5-hdfeos0/${LIBDIR}
	#mv hdf-eos5.pc debian/libhe5-hdfeos-dev/${LIBDIR}/pkgconfig
	chrpath -d debian/tmp/${LIBDIR}/libhe5_hdfeos.so.0.0.0
	#mv debian/tmp/${LIBDIR}/libhe5_hdfeos.so.0.0.0  debian/libhe5-hdfeos0/${LIBDIR}
	#cp debian/tmp/usr/lib/*/*.a debian/libhe5-hdfeos-dev/${LIBDIR}
	# cp -a samples/* debian/libhe5-hdfeos-dev/usr/share/doc/libhe5-hdfeos-dev/examples
	chmod -x debian/libhe5-hdfeos-dev/usr/share/doc/libhe5-hdfeos-dev/examples/*
